import * as mc from '@minecraft/server';

export const console = mc.world.getDimension('minecraft:overworld');
const limit = 256

export class Console {
    constructor(player) {
        this.console = player;
        this.commands = 0;
    }
    run(command) {
        return new Promise(async (resolve) => {
            if (this.commands < 127) {
                this.console.runCommandAsync(command);
            } else {
                await this.console.runCommandAsync(command);
                this.commands = 0;
            }
            this.commands = this.commands + 1;
            resolve(true);
        })
    }
    awaitRun(command) {
        return new Promise(async (resolve) => {
            await this.console.runCommandAsync(command);
            this.commands = 1;
            resolve(true);
        })
    }
}

export const cmd = new Console(console);

export class database {
    constructor(id, init) {
        this.id = id;
        if (mc.world.scoreboard.getObjective(`${this.id}`) == null) {
            this.data = init;
            console.runCommandAsync(`scoreboard objectives add ${id} dummy ${id}`)
            console.runCommandAsync(`scoreboard players set ${'"' + JSON.stringify(this.data).replaceAll('"', "'") + '"'} ${this.id} 0`);
        } else {
            let participant = mc.world.scoreboard.getObjective(`${this.id}`).getParticipants()[0];
            this.data = JSON.parse(participant.displayName.replaceAll("'", '"'));
        }
    }
    set(value) {
        console.runCommandAsync(`scoreboard players reset ${'"' + JSON.stringify(this.data).replaceAll('"', "'") + '"'} ${this.id}`)
        this.data = value;
        console.runCommandAsync(`scoreboard players set ${'"' + JSON.stringify(this.data).replaceAll('"', "'") + '"'} ${this.id} 0`);
    }
    get() {
        let copy = JSON.stringify(this.data);
        return JSON.parse(copy);
    }
}

export class log {
    constructor(id, init) {
        this.id = id;
        if (mc.world.scoreboard.getObjective(`${this.id}`) == null) {
            this.data = init;
            this.init = cmd.awaitRun(`scoreboard objectives add ${this.id} dummy ${this.id}`).then((r) => {
                return new Promise((resolve, reject) => {
                    cmd.awaitRun(`scoreboard players set ${'"' + JSON.stringify(this.data).replaceAll('"', "'") + '"'} ${this.id} 0`).then((r) => {
                        resolve(true)
                    });
                });
            })
        } else {
            let participants = mc.world.scoreboard.getObjective(`${this.id}`).getParticipants();
            let array = [];
            for (let participant of participants) {
                array = array.concat(JSON.parse(participant.displayName.replaceAll("'", '"')))
            }
            this.data = array;
        }
    }
    async set(value) {
        let participants;
        try {
            participants = mc.world.scoreboard.getObjective(`${this.id}`).getParticipants();
        } catch (e) {
            await this.init.then((r) => {
                return true;
            })
            participants = mc.world.scoreboard.getObjective(`${this.id}`).getParticipants();
        }
        for (let participant of participants) {
            await cmd.awaitRun(`scoreboard players reset ${'"' + participant.displayName + '"'} ${this.id}`)
        }
        let page;
        for (let i = 0; i < value.length; i += limit) {
            page = value.slice(i, i + limit)
            await cmd.run(`scoreboard players set ${'"' + JSON.stringify(page).replaceAll('"', "'") + '"'} ${this.id} 0`);
        }
        this.data = value;
    }
    get() {
        let copy = JSON.stringify(this.data);
        return JSON.parse(copy);
    }
}